<template>
    <div class="row">
        <div class="col-12">
            <BudgetNavigation/>
        </div>
    </div>
    <div v-if="details">
        <div class="row mt-3">
            <div class="col-6">
                <h4>Детали бюджета</h4>
            </div>
            <div class="col-6 mt-auto text-end">
                <BudgetEditModeSelector
                    v-if="editable"
                    v-model:editMode="editMode"/>
            </div>
        </div>
        <div class="row">
            <div class="col-3">Год</div>
            <div class="col-6">{{details.year}}</div>
        </div>
        <div class="row">
            <div class="col-3">Тип</div>
            <div class="col-6">{{details.type}}</div>
        </div>
        <div class="row">
            <div class="col-3">Название</div>
            <div class="col-6">{{details.name}}</div>
        </div>
        <div class="row">
            <div class="col-3">Дата</div>
            <div class="col-6">{{detailsLuxonDate.toLocaleString()}}</div>
        </div>
        <hr/>
        <div class="row">
            <div class="col-4 mt-auto">
                <BudgetCodeTypeSelector
                    v-model:codeType="codeType"
                    :nullValueText="'Все'"/>
            </div>
            <div class="col-4 mt-auto">
                <label class="form-check-label" for="budget-presentation-dropdown">
                    Отображение
                </label>
                <BudgetPresentationDropdown
                    :id="'budget-presentation-dropdown'"
                    v-model:selectedPresentationId="selectedPresentationId"
                    :presentationsList="presentationsList"/>
            </div>
            <div class="col-4 mt-auto d-flex align-items-end flex-column">
                <BudgetViewTypeSelector
                    v-model:viewType="viewType"/>
            </div>
        </div>
    </div>
    <div v-if="view">
        <div class="row">
            <div class="col-12">
                <BudgetViewCard
                    :view="view"
                    :editMode="editMode"/>
            </div>
        </div>
    </div>
</template>

<script>
    import BudgetEditModeSelector from '../BudgetEditModeSelector'
    import BudgetNavigation from '../BudgetNavigation';
    import BudgetCodeTypeSelector from '../Codes/BudgetCodeTypeSelector'
    import BudgetPresentationDropdown from '../Presentations/BudgetPresentationDropdown'
    import BudgetViewTypeSelector from '../Views/BudgetViewTypeSelector'
    import BudgetViewCard from '../Views/BudgetViewCard'
    import { BudgetDetailsService } from '../../services/budgetDetailsService'
    import { BudgetPresentationsService } from '../../services/budgetPresentationsService'
    import { BudgetViewsService } from '../../services/budgetViewsService'
    import { defaultHandleErrorFunction } from '@/services/http-common'
    import { codeTypes, viewTypes } from '@/services/values'
    import { DateTime } from "luxon";

    const DEFAULT_CODE_TYPE = null
    const DEFAULT_VIEW_TYPE = viewTypes.GRAPH

    export default {
        name: 'BudgetDetailsPage',
        components: {
            BudgetEditModeSelector,
            BudgetNavigation,
            BudgetCodeTypeSelector,
            BudgetPresentationDropdown,
            BudgetViewCard,
            BudgetViewTypeSelector
        },
        props: {
            detailsId: Number,
            presentationId: Number,
            codeTypeInput: {
                type: String,
                required: false,
                validator: value => [codeTypes.INCOME, codeTypes.EXPENDITURE, 'null'].indexOf(value) !== -1
            },
            viewTypeInput: {
                type: String,
                required: false,
                validator: value => [viewTypes.TABLE.value, viewTypes.TREE.value, viewTypes.GRAPH.value, 'null'].indexOf(value) !== -1
            },
        },
        data() {
            return {
                details: null,
                presentationsList: [],
                selectedPresentationId: this.presentationId,
                view: null,
                editMode: false,
                codeType: Object.values(codeTypes).find((item) => { return item === this.codeTypeInput; }) || DEFAULT_CODE_TYPE,
                viewType: Object.values(viewTypes).find((item) => { return item.value === this.viewTypeInput; }) || DEFAULT_VIEW_TYPE
            }
        },
        computed: {
            detailsLuxonDate: function() {
                return DateTime.fromISO(this.details.date);
            },
            editable: function() {
                return this.viewType != null && this.viewType.value!== viewTypes.GRAPH.value
            }
        },
        methods: {
            updateDetailsList() {
                budgetDetailsService
                    .getById(this.detailsId)
                    .then(response => this.details = response.data)
                    .catch(defaultHandleErrorFunction);
            },
            updatePresentationsList() {
                if (this.details && this.details.municipalityId)
                    budgetPresentationsService
                        .get(this.details.municipalityId)
                        .then(response => {
                            this.presentationsList = response.data;
                            if (this.presentationsList.length > 0 && !this.selectedPresentationId)
                                this.selectedPresentationId = this.presentationsList[0].id;
                        })
                        .catch(defaultHandleErrorFunction);
            },
            updateView() {
                if (this.detailsId && this.selectedPresentationId) {
                    let query = {};
                    if (this.codeType != undefined && this.codeType != DEFAULT_CODE_TYPE)
                        query.codeType = this.codeType;
                    if (this.viewType != undefined && this.viewType.value != DEFAULT_VIEW_TYPE.value)
                        query.viewType = this.viewType.value;
                    this.$router.push({ name: 'budget-details', params: {detailsId: this.detailsId, presentationId: this.selectedPresentationId}, query: query })
                    budgetViewsService
                        .get(this.detailsId, this.selectedPresentationId, this.codeType)
                        .then(response => {
                            this.view = response.data;
                            this.view.viewType = this.viewType;
                            this.view.codeType = this.codeType;
                        })
                        .catch(defaultHandleErrorFunction);
                }
            }
        },
        watch: {
            detailsId: function (value) {
                this.updateDetailsList();
                this.updateView();
            },
            selectedPresentationId: function (value) {
                this.updateView();
            },
            codeType: function(value) {
                this.updateView();
            },
            viewType: function(value) {
                this.updateView();
            },
            showInactive: function(value) {
                this.updateView();
            },
            details: function (value) {
                this.updatePresentationsList();
            },
        },
        created() {
            this.updateDetailsList();
            this.updateView();
        }
    };

    const budgetDetailsService = new BudgetDetailsService();
    const budgetPresentationsService = new BudgetPresentationsService();
    const budgetViewsService = new BudgetViewsService();
</script>
